Public Class Form1
    Private m_Feiertage As New Feiertagsberechnung

    Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        For I As Integer = 0 To 15
            Me.ComboBoxBundesland.Items.Add(New BundeslandComboItem(2 ^ I, m_Feiertage.Bundeslandname(2 ^ I)))
        Next
        Me.ComboBoxBundesland.SelectedIndex = 15
        Me.TextBoxJahr.Text = Year(Now).ToString
    End Sub

    Private Sub TextBoxJahr_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles TextBoxJahr.KeyPress
        If Not IsNumeric(e.KeyChar) Then
            If e.KeyChar = ControlChars.Back Then
            Else
                e.Handled = True
            End If
        End If
    End Sub


    Private Sub TextBoxJahr_Validating(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles TextBoxJahr.Validating
        Dim txt As String = TextBoxJahr.Text
        If txt.Length < 4 Then
            txt = txt.PadRight(4, "0")
            Try
                Dim Zahl As Integer = CInt(TextBoxJahr.Text)
                If Zahl = 0 OrElse Zahl > 2100 Then
                    TextBoxJahr.Text = Year(Now).ToString
                End If
            Catch ex As Exception
                TextBoxJahr.Text = Year(Now).ToString
            End Try

        End If
    End Sub

    Private Sub ButtonFertig_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonFertig.Click
        Me.Close()
    End Sub

    Private Sub ButtonNeuerKalender_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonNeuerKalender.Click
        Dim XLApp As Object
        Dim XLBook As Object
        Dim XLSheet As Object

        Dim Excel_LiefSchon As Boolean = False

        Try
            XLApp = GetObject(, "Excel.Application")
            Excel_LiefSchon = True
        Catch ex As Exception
            Try
                XLApp = CreateObject("Excel.Application")
            Catch ex1 As Exception
                MessageBox.Show(ex1.Message, "Excel Jahreskalender", MessageBoxButtons.OK, MessageBoxIcon.Stop)
                Exit Sub
            End Try
        End Try

        If XLApp Is Nothing Then Exit Sub

        XLApp.DisplayAlerts = False
        XLBook = XLApp.Workbooks.Add

        XLApp.Visible = True
        XLSheet = XLBook.Worksheets(1)

        XLSheet.Cells(1, 1) = "Jahreskalender " & Me.TextBoxJahr.Text & " fr das Bundesland " & Me.ComboBoxBundesland.Text
        XLSheet.Cells(1, 1).Font.size = 12
        Dim Startdatum As New DateTime(CInt(Me.TextBoxJahr.Text), 1, 1)

        Dim Testdatum As DateTime = Startdatum
        Dim Zeile, Spalte As Integer
        Dim FreieTageMarkieren As Boolean = Me.CheckBoxFreieTage.Checked

        While Testdatum.Year = Startdatum.Year

            Spalte = (Testdatum.Month - 1) * 3 + 1
            Zeile = Testdatum.Day + 3

            XLSheet.Cells(Zeile, Spalte) = Format(Testdatum, "ddd, dd.MM.")
            XLSheet.Cells(Zeile, Spalte).HorizontalAlignment = -4152

            If Testdatum.DayOfWeek = DayOfWeek.Saturday Or Testdatum.DayOfWeek = DayOfWeek.Sunday Then
                XLSheet.Cells(Zeile, Spalte).Font.Bold = True
                XLSheet.Cells(Zeile, Spalte).Font.Color = RGB(255, 0, 0)
                If FreieTageMarkieren Then XLSheet.Cells(Zeile, Spalte + 2) = "f"
            Else
                If FreieTageMarkieren Then XLSheet.Cells(Zeile, Spalte + 2) = 1
            End If

            Testdatum = Testdatum.AddDays(1)
        End While

        Dim Itm As BundeslandComboItem = Me.ComboBoxBundesland.SelectedItem
        Dim Land As Bundeslaender = Itm.Bundesland

        For I As Integer = 1 To 16
            If m_Feiertage.IstFeiertagIn(I, Land) Then
                Testdatum = m_Feiertage.Feiertagsdatum(I, Startdatum.Year)
                Spalte = (Testdatum.Month - 1) * 3 + 1
                Zeile = Testdatum.Day + 3
                XLSheet.Cells(Zeile, Spalte).Font.Bold = True
                XLSheet.Cells(Zeile, Spalte + 1).Font.Bold = True
                XLSheet.Cells(Zeile, Spalte).Font.Color = RGB(255, 0, 0)
                XLSheet.Cells(Zeile, Spalte + 1).Font.Color = RGB(255, 0, 0)
                XLSheet.Cells(Zeile, Spalte + 1) = m_Feiertage.Feiertagsname(I)
                If FreieTageMarkieren Then XLSheet.Cells(Zeile, Spalte + 2) = "f"
            End If
        Next



        'XLBook.Close(False)
        'If Not Excel_LiefSchon Then XLApp.Quit()

        System.Runtime.InteropServices.Marshal.ReleaseComObject(XLSheet)
        System.Runtime.InteropServices.Marshal.ReleaseComObject(XLBook)
        System.Runtime.InteropServices.Marshal.ReleaseComObject(XLApp)

    End Sub

End Class
